/*
 * Copyright 2004-2007 Haiku Inc. All rights reserved.
 * Distributed under the terms of the MIT License.
 *
 * Authors:
 *		Some Author, optional@email.com
 */
#ifndef _THE_CLASS_H_
#define _THE_CLASS_H_

#include "AlphabeticallySorted.h"
#include "LocalHeaders.h"

#include <AlsoAlphabeticallySorted.h>
#include <SystemHeaders.h>

class ClassForwardDeclarations;
class SortedAlphabetically;

struct some_struct {
	int32	item_count;
	void	*elements;

	union {
		int32	integral;
		float	decimal;
		void *	pointer;
	} storage;
};

namespace SomeOptionalNamespace {

class TheClass : public TheBaseClass {
public:
								TheClass();
	virtual						~TheClass();

	virtual	void				SomeVirtualMethod();
			void				SomeOtherMethod(void *argumentList,
									int32 argumentCount);

			// Comment that may explain some specific of the following method
			bool				MethodWithLongNameThatFillsLine(
									int32 theFirstArgument,
									int32 theSecondArgument,
									int32 andTheThird);

			/*	A multi line comment stating various conventions that should
				be followed when using the function below */
			void *				MethodThatReturnsPointer();
	virtual	const char *		VirtualMethodThatReturnsStringAndIsConst()
									const;
			void				ShorterMethodThatIsConst() const;
			const BString &		AnotherMethod();

	typedef	void				(*CallbackFunction)(void *cookie);
	typedef	int32				locally_used_type;

private:
	friend	class				SomeFriendClass;

	static	void				_PrivateCallbackFunc(void *cookie);
			void				_PrivateMethodWithUnderscorePrefix(
									void *andSomeArgument);

			struct internal_struct {
				int32		some_index;
				void *		cookie;
				SomeClass *	object;
			};

			union {
				float	float_type;
				int32	int_type;
				char *	string_type;
			}					fDirectlyUsedUnion;

			enum {
				FIRST_ENUM_VALUE				= 0x00,
				SECOND_AND_LONGER_ENUM_VALUE	= 0x01,
				THIRD_ENUM_VALUE				= 0x02
			};

			// Note on the following member(s)
			BObjectList<SomeTypeThatMakesItVeryLong>	fSomeTypeList;
			void *				fSomePointer;
			int32				fCount;

			// Some other comment to explain a specific
	mutable	float				fMutableMember;
};

} // namespace SomeOptionalNamespace

#endif // _THE_CLASS_H_
